﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
//[0] 
using System.Data.SqlClient;//

public partial class FrmMemoList : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack) // 처음 로드시
        {
            GetMemoList();
        }
    }

    //[!] 데이터 출력 전담 메서드(함수)
    private void GetMemoList()
    { 
        //[1] 변수 선언부
        string strSql =
            //"Select * From Memos " 
            //+ "Order By Num Desc";
            "procListMemo";
        //[2] SqlConnection
        SqlConnection objCon = 
            new SqlConnection();
        objCon.ConnectionString = 
            "server=(local);database=MemoDB;"
            + "uid=Memo;pwd=Memo;";
        objCon.Open();
        //[3] SqlCommand
        SqlCommand objCmd = new SqlCommand();
        objCmd.Connection = objCon;
        objCmd.CommandText = strSql;//일반SQL문
        objCmd.CommandType = //CommandType.Text;
            CommandType.StoredProcedure;
        //[4] SqlDataAdapter
        SqlDataAdapter objDa = 
            new SqlDataAdapter();
        objDa.SelectCommand = objCmd;
        //[5] DataSet
        DataSet objDs = new DataSet();
        objDa.Fill(objDs, "Memos");
        //[6] GridView/DataGrid 컨트롤
        this.ctlMemoList.DataSource = objDs;
        this.ctlMemoList.DataBind();
    }
    
    protected void ctlMemoList_PageIndexChanging(object sender, GridViewPageEventArgs e)
    {
        this.ctlMemoList.PageIndex = 
            e.NewPageIndex;//새로운 페이지
        GetMemoList();//다시 로드
    }
    protected void btnWrite_Click(object sender, EventArgs e)
    {
        Response.Redirect(
            "./FrmMemoWrite.aspx");
    }
    protected void btnSearch_Click(object sender, EventArgs e)
    {
        //[1] Init
        string strSearchField =
            this.lstSearchField.SelectedValue;
        string strSearchQuery =
            this.txtSearchQuery.Text.Trim();
        string strSql =
        #region +
            //[a] 검색 예시문
            //"Select * From Memos " 
            //+ "Where Name Like '%길%'";
            //[b] 인라인 SQL문 : 데이터->"+변수+"
            //"Select * From Memos "
            //+ "Where " + strSearchField 
            //+ " Like '%" + strSearchQuery 
            //+ "%' Order By Num Desc";

            //[c] Named 매개변수 방식
            //"Select * From Memos " 
            //+ "Where Name Like '%@Name%' ";
            //"Select * From Memos " 
            //+ "Order By Num Desc";
        #endregion
            //[d] 저장 프로시저 방식
            "procSearchMemo";//저장프로시저명
        //Response.Write(strSql);
        //Response.End();
        //[2] SqlConnection
        #region SqlConnection
        SqlConnection objCon =
            new SqlConnection();
        objCon.ConnectionString = @"
            server=(local);
            database=MemoDB;
            uid=Memo;pwd=Memo;
        ";
        objCon.Open();
        #endregion
        //[3] SqlCommand
        SqlCommand objCmd = new SqlCommand();
        objCmd.Connection = objCon;
        objCmd.CommandText = strSql;
        objCmd.CommandType = //CommandType.Text;
            CommandType.StoredProcedure;//
        //[!] 파라미터 추가
        objCmd.Parameters.Add(
            "@SearchField", SqlDbType.VarChar, 10);
        objCmd.Parameters["@SearchField"].Value =
            strSearchField;
        objCmd.Parameters.Add(
            "@SearchQuery", SqlDbType.VarChar, 50);
        objCmd.Parameters["@SearchQuery"].Value =
            strSearchQuery;
        //[4] SqlDataAdapter
        SqlDataAdapter objDa =
            new SqlDataAdapter();
        objDa.SelectCommand = objCmd;
        //[5] DataSet : 메모리 상의 DB
        DataSet objDs = new DataSet();
        objDa.Fill(objDs, "Memos");
        #region //[!] 데이터 검색 : DataView 클래스
        //DataView objDv = new DataView();
        //objDv = 
        //    objDs.Tables["Memos"].DefaultView;
        //objDv.RowFilter = 
        //    "" + strSearchField 
        //    + " Like '%" + strSearchQuery 
        //    + "%'";
        #endregion
        //[6] GridView/DataGrid
        this.ctlMemoList.DataSource = objDs;
        this.ctlMemoList.DataBind();//출력
        //[7] Dispose
        objCon.Close();
    }
}
